Bug 479393 - (__int128_t)0>>128: unable to generate reloads
(__int128_t)0>>128: unable to generate reloads
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: gcc4 (Show other bugs)
10
x86_64 Linux
low Severity medium
: ---
: ---
Assigned To: Jakub Jelinek
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-01-09 04:40 EST by James Hogan
Modified: 2009-07-13 05:48 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-07-13 05:48:52 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Preprocessed source (338 bytes, text/x-csrc)
2009-01-09 04:40 EST, James Hogan
no flags Details

  None (edit)
Description James Hogan 2009-01-09 04:40:55 EST
Created attachment 328530 [details]
Preprocessed source

Description of problem:

GCC crashes with "unable to generate reloads" when right-shifting an __int128_t  by 128 places.

Version-Release number of selected component (if applicable):

`gcc -v` gives:
Using built-in specs.
Target: x86_64-redhat-linux
Configured with: configure --prefix=/usr --mandir=/usr/share/man --infodir=/usr/share/info --with-bugurl=http://bugzilla.redhat.com/bugzilla --enable-bootstrap --enable-shared --enable-threads=posix --enable-checking=release --with-system-zlib --enable-__cxa_atexit --disable-libunwind-exceptions --enable-languages=c,c++,objc,obj-c++,java,fortran,ada --enable-java-awt=gtk --disable-dssi --enable-plugin --with-java-home=/usr/lib/jvm/java-1.5.0-gcj-1.5.0.0/jre --enable-libgcj-multifile --enable-java-maintainer-mode --with-ecj-jar=/usr/share/java/eclipse-ecj.jar --disable-libjava-multilib --with-cpu=generic --build=x86_64-redhat-linux
Thread model: posix
gcc version 4.3.0 20080428 (Red Hat 4.3.0-8) (GCC) 

How reproducible:

always

Steps to Reproduce:
1. compile attached preprocessed source with gcc
  
Actual results:

`gcc bug_rh_173101_me.cc` says:

bug_rh_173101_me.cc: In function ‘int main()’:
bug_rh_173101_me.cc:4: warning: right shift count >= width of type
bug_rh_173101_me.cc:5: error: unable to generate reloads for:
(insn 7 6 8 2 bug_rh_173101_me.cc:4 (parallel [
            (set (reg:TI 0 ax [orig:58 D.2027 ] [58])
                (ashiftrt:TI (reg:TI 0 ax [61])
                    (const_int -128 [0xffffffffffffff80])))
            (clobber (reg:CC 17 flags))
        ]) 473 {*ashrti3_2} (expr_list:REG_DEAD (reg:TI 0 ax [61])
        (expr_list:REG_UNUSED (reg:CC 17 flags)
            (nil))))
bug_rh_173101_me.cc:5: internal compiler error: in find_reloads, at reload.c:374
4
Please submit a full bug report,
with preprocessed source if appropriate.
See <http://bugzilla.redhat.com/bugzilla> for instructions.
Preprocessed source stored into /tmp/cc2LvvVE.out file, please attach this to yo
ur bugreport.

Expected results:

1) a sensible warning
2) code generated setting the __int128_t to 0 if right shifting more than bit-width.

Additional info:

see also bug #173101 where i originally mentioned this error. This bug has since apparently fixed the original problem but not the one provided by me.
Comment 1 Bug Zapper 2009-06-09 23:28:43 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 James Hogan 2009-06-10 04:40:22 EDT
defect still present in updated fedora 10, gcc 4.3.2.

gcc -v:

Using built-in specs.
Target: x86_64-redhat-linux
Configured with: configure --prefix=/usr --mandir=/usr/share/man --infodir=/usr/share/info --with-bugurl=http://bugzilla.redhat.com/bugzilla --enable-bootstrap --enable-shared --enable-threads=posix --enable-checking=release --with-system-zlib --enable-__cxa_atexit --disable-libunwind-exceptions --enable-languages=c,c++,objc,obj-c++,java,fortran,ada --enable-java-awt=gtk --disable-dssi --enable-plugin --with-java-home=/usr/lib/jvm/java-1.5.0-gcj-1.5.0.0/jre --enable-libgcj-multifile --enable-java-maintainer-mode --with-ecj-jar=/usr/share/java/eclipse-ecj.jar --disable-libjava-multilib --with-cpu=generic --build=x86_64-redhat-linux
Thread model: posix
gcc version 4.3.2 20081105 (Red Hat 4.3.2-7) (GCC)

slightly different line number in error message, which is otherwise identical to above:

bug_rh_173101_me.cc:5: internal compiler error: in find_reloads, at reload.c:3767
Comment 3 Jakub Jelinek 2009-07-13 05:48:52 EDT
Compiles just fine with gcc 4.4 and 4.5.

Note You need to log in before you can comment on or make changes to this bug.